/*
 * Demostration print simple under T-Gtk and Harbour
 * (c)2004 Rafa Carmoma
 * cFileNamePrint is name the output file print
 * lDialog if you view select options from dialog
 * lDump if view dump caracterist printer
 */
#include "gnomeprint.ch"


Function Main( cFileNamePrint, lDialog, lDump )

        local job
        Local gpc
        Local config, lResult
        Local cOutput := ".pdf"

        if Empty( cFileNamePrint )
           cFileNamePrint := "output"
        endif

        if Empty( lDialog ) ; lDialog := .F.; else ; lDialog := .T. ; endif
        if Empty( lDump )   ; lDump   := .F.; else ; lDump   := .T. ;endif

        g_type_init ()

        job = gnome_print_job_new( )
        gpc = gnome_print_job_get_context( job )

        config = gnome_print_job_get_config (job)

        if !gnome_print_config_set (config, "Printer", "PDF")
           gnome_print_config_set (config, "Printer", "GENERIC")
           cOutPut := ".ps"
        endif
        gnome_print_job_print_to_file (job, cFileNamePrint + cOutput )

        gnome_print_config_set(config, GNOME_PRINT_KEY_PREFERED_UNIT, "CM")
        gnome_print_config_set(config, GNOME_PRINT_KEY_PAPER_SIZE, "Executive")
        //gnome_print_config_set(config, GNOME_PRINT_KEY_NUM_COPIES, "2" )

        // Algunas de las opciones que hemos definido son tenidas en cuenta
        // en el dialog, otras, como las copias, las tenemos que meter a mano
        if lDialog
           if !gtk_print_dialog_new( job, " Este titulo ",;
               nOr( GNOME_PRINT_DIALOG_RANGE,GNOME_PRINT_DIALOG_COPIES ) )
               g_object_unref( config )
               g_object_unref( gpc )
               g_object_unref( job )
               g_print( "Cancelamos impresion" )
               QUIT
           endif
        endif

        if lDump
           Caracteristicas( config )
        endif

        my_draw( gpc )


        gnome_print_job_close (job)
        gnome_print_job_print (job)

        g_object_unref( config )
        g_object_unref( gpc )
        g_object_unref( job )


return nil

STATIC FUNCTION my_draw( gpc )
       Local font
       Local radius := 50

       gnome_print_beginpage (gpc, "1")

       font = gnome_font_find_closest ("Sans Regular", 12)
       gnome_print_setfont (gpc, font)
       gnome_print_moveto (gpc, 100, 500)
       gnome_print_show (gpc, "1 - ESTO ES UN EJEMPLO")
       g_object_unref( font )


       gnome_print_setrgbcolor( gpc,1.0,0.45,0.76)
       font = gnome_font_find_closest ("Sans Bold Italic", 24)
       gnome_print_setfont (gpc, font)
       gnome_print_moveto (gpc, 100, 470)
       gnome_print_show (gpc, "2 -IMPRESION DESDE T-GTK" )

       gnome_print_setrgbcolor( gpc,0.0,0.0,0.0 )
       gnome_print_moveto (gpc, 100, 440)
       gnome_print_rotate(gpc, 30 )
       gnome_print_show (gpc, "3- Para GNU/Linux " )

       gnome_print_showpage (gpc)

       gnome_print_beginpage (gpc, "2")
       gnome_print_moveto (gpc, 50, 600)
       gnome_print_show (gpc, "La segunda pagina lista para primitivas")

       gnome_print_translate(gpc, 10, 300)
       gnome_print_setlinewidth( gpc,5 )
       gnome_print_setrgbcolor( gpc,1.0,0.0,0.0 )
       gnome_print_newpath( gpc )
       gnome_print_arcto(gpc, radius, radius,  radius, 1, 360, 0)
       gnome_print_stroke(gpc)

       gnome_print_setlinewidth( gpc,2 )
       gnome_print_setrgbcolor( gpc,0.49,0.5,1.0 )
       gnome_print_moveto(gpc, 10, 10)
       gnome_print_newpath( gpc )
       gnome_print_arcto(gpc, radius, radius,  radius, 1, 360, 0)
       gnome_print_fill(gpc)

       gnome_print_setlinewidth( gpc,5 )
       gnome_print_setrgbcolor( gpc,0.0,1.0,0.0 )
       gnome_print_moveto(gpc, 100, 100)
       gnome_print_lineto(gpc, 200, 200)
       gnome_print_stroke(gpc)

       gnome_print_showpage (gpc)

       g_object_unref( font )


return nil


// Podemos saber longitudes como:
Static Func Caracteristicas( config )
 Local nWidth, nHeight

 gnome_print_config_get_length( config, GNOME_PRINT_KEY_PAPER_WIDTH, @nWidth )
 gnome_print_config_get_length( config, GNOME_PRINT_KEY_PAPER_HEIGHT, @nHeight )
 g_print( "Ancho: "+ cValtoChar( nWidth )+;
          " Alto: " + cValtoChar( nHeight )+HB_OSNEWLINE() )

 // Volcado de depuracion , volcarlo a disco printsimple > pepe.txt
 // para verlo mejor
 gnome_print_config_dump( config )

return nil
